//15/07/2022 02:19:36 FanControl_10.ino
//Arduino Nano 33 BLE vehicle temperatuure data to Android App [App Inventor]

const int igRadPin = A0;      // Radiator Input Thermister
const int igCndPin = A1;      // Condenser Input Thermister
const int igAuxPin = A2;      // Auxilary Input Not used at this time
const int igFanPin = 9;       // Set Fan pin
long lgPeriod = 2000;         // Check period (first run 2 seconds, subsequent 10 seconds)
bool bgNext = false;          // For fake test values
bool bgUpdate = false;        // Subseqent check period 10 seconds
int igSensorVal[3];           // Includes Temperature values and Fan Speed

long lgPreviousMillis = 0;    // last time the temperature levels were checked, in ms

                    /*
                      Temperatur Monitor

                      This example creates a BluetoothLow Energy peripheral with the standard Temperature service and
                      level characteristic. Pins A0, A1 and A2 are used to calculate the temperatures of 3 sensors.
                      The data is calculated by the time set in the constant Period.

                      The circuit:
                      - Arduino MKR WiFi 1010, Arduino Uno WiFi Rev2 board, Arduino Nano 33 IoT,
                        Arduino Nano 33 BLE, or Arduino Nano 33 BLE Sense board.

                      You can use a generic Bluetooth Low Energy central app, like LightBlue (iOS and Android) or
                      nRF Connect (Android), to interact with the services and characteristics
                      created in this sketch.

                      This example code is in the public domain.
                    */

#include <ArduinoBLE.h>

#define BLE_SERVICE_UUID "0000ffe0-0000-1000-8000-00805f9b34fb"
#define BLE_CHARACTERISTIC_UUID "0000ffe1-0000-1000-8000-00805f9b34fb"
 
// Define the Temperature Service
BLEService TempService(BLE_SERVICE_UUID);  // BluetoothLE Temperature Service

// Define Characteristic
BLEStringCharacteristic TempCharacteristic(BLE_CHARACTERISTIC_UUID, BLEWrite | BLENotify, 32); 

void setup()
{
               Serial.begin(9600);    // initialize serial communication with PC Arduino Serial Monitor

               pinMode(LED_BUILTIN, OUTPUT); // initialize the built-in LED pin to indicate when a central is connected

               // begin initialization
               if (!BLE.begin())
               {
                         Serial.println("starting BLE failed!");

                         while (1);
               }

               Serial.println("BLE Started");

               // set advertised local name and service UUID:

               BLE.setLocalName("VehTemp"); //No spaces in name, max 10 bytes
               Serial.println("BLE Local Name = VehTemp");

               BLE.setAdvertisedService(TempService); //Advertise the availability of the Service
               
               // add the characteristic to the service
               TempService.addCharacteristic(TempCharacteristic); // All integer Values

               // add service
               BLE.addService(TempService); // add the service UUID
               
               // set the initial value for the characteristic
               //TempCharacteristic.writeValue(0);
               
               // start advertising
               BLE.advertise();
               
               Serial.println("BLE VehTemp Peripheral");
               Serial.println("Bluetoothdevice active, waiting for connections...");
}

void loop()
{
               // wait for a BluetoothLow Energy central
               BLEDevice central = BLE.central();

               // if a central is connected to the peripheral:
               if (central)
               {
                         Serial.print("Connected to central: ");
                         // print the central's BT address:
                         Serial.println(central.address());
                         // turn on the LED to indicate the connection:
                         digitalWrite(LED_BUILTIN, HIGH);

                         // check the temperature levels every Period (ms)
                         // while the central is connected:

                         while (central.connected())
                         {
                                   // if Period ms have passed, check the temperature levels:
                                   if ((millis() - lgPreviousMillis) > lgPeriod)
                                   {
                                     lgPreviousMillis = millis();

                                     updateTempAndFanSpeed();

                                     bgUpdate = true;
                                   }

                                   if (bgUpdate == true) {lgPeriod = 10000;} //Subsequent checks every 10 seconds
                         }

                         if (!central.connected())
                         {
                                   // when the central disconnects, turn off the LED:
                                   digitalWrite(LED_BUILTIN, LOW);
                                   Serial.print("Disconnected from central: ");
                                   Serial.println(central.address());
                         }
               }
}

void updateTempAndFanSpeed()
{
// Read the current voltage level on each analog input pin.
// This is used here to simulate the charge level of temperatures.

//int Rad = analogRead(igRadPin);
//int Cnd = analogRead(igCndPin);
//int Aux = analogRead(igAuxPin);

//int RadLevel = map(Rad, 0, 1023, 0, 100);
//int CndLevel = map(Cnd, 0, 1023, 0, 100);
//int AuxLevel = map(Aux, 0, 1023, 0, 100); 

// Fake values for testing

char sSensorVals[32];

               if (bgNext == false)
               {
                         igSensorVal[0] = 10; //RadLevel
                         igSensorVal[1] = 11; //CndLevel
                         igSensorVal[2] = 12; //AuxLevel
                         igSensorVal[3] = 13; //FanSpeed

                         bgNext = true;
               }
               else
               {
                         igSensorVal[0] = igSensorVal[0] + 4; //RadLevel
                         igSensorVal[1] = igSensorVal[1] + 4; //CndLevel
                         igSensorVal[2] = igSensorVal[2] + 4; //AuxLevel
                         igSensorVal[3] = igSensorVal[3] + 4; //FanSpeed
               }

               Serial.print("Rad Level % is now: "); Serial.println(igSensorVal[0]);
               Serial.print("Cnd Level % is now: "); Serial.println(igSensorVal[1]);
               Serial.print("Aux Level % is now: "); Serial.println(igSensorVal[2]);
               Serial.print("Fan Speed is now: ");   Serial.println(igSensorVal[3]);

               sprintf(sSensorVals, "%u|%u|%u|%u\0", igSensorVal[0], igSensorVal[1], igSensorVal[2], igSensorVal[3]);

               TempCharacteristic.writeValue(sSensorVals);
}
